#pip install numpy, matplotlib si le module n'est pas deja present
#
#La couleur de chaque pixels est codee en (R,G,B)
#Le rouge est code (255,0,0), le vert (0,255,0), le bleu (0,0,255),
#le blanc (255,255,255) et le noir (0,0,0)


import matplotlib.image as mpimg
import matplotlib.pyplot as plt
import numpy as np
import datetime

# parametres par defaut:

pixels_ori = 400
xmin_ori = -2.5
xmax_ori = 0.5
ymin_ori = -1.5
ymax_ori = 1.5
bouclesmax = 200
z_ori = 1


#demande d'entree des differents parametres

quitch = ""

while quitch == "":

    pixelsch = input("Taille de l image (400 pixels par defaut) = ")
    nch = input("exposant (2 par defaut): n = ")
    zch = input("zoom (1 par defaut): z =")
    x0ch = input("Centre de la zone de zoom (0 par defaut): x0 =")
    y0ch = input("Centre de la zone de zoom (0 par defaut): y0 =")

    if pixelsch == "":
        pixels = pixels_ori
        p = int(pixels/2)
    else :
        pixels = int(pixelsch)
        p = int((pixels+1)/2)

    if x0ch == "":
        x0=0
    else :
        x0=(float(x0ch)-(pixels_ori/2))/pixels*(xmax_ori-xmin_ori)

    if y0ch == "":
        y0=0
    else :
        y0=((pixels_ori/2)-float(y0ch))/pixels*(ymax_ori-ymin_ori)

    if zch == "":
        z=z_ori
    else :
        z=int(zch)


    if nch == "":
        n=2
    else :
        n=float(nch)

    #adaptation de la fenetre si zoom:

    xmin = x0 + xmin_ori/z
    ymin = y0 + ymin_ori/z
    xmax = x0 + xmax_ori/z
    ymax = y0 + ymax_ori/z

    start_delay = datetime.datetime.now()
    img = np.zeros((pixels,pixels,3),dtype=np.uint8) #definit l'image comme une matrice de triplets (Rouge,Vert,Bleu) correspondant a la couleur de chaque pixels

    for line in range(p):     #boucles parcourant la grille de pixel, la symetrie de l'ensemble de Mandelbrot fait qu'il n'est pas necessaire d'aller au dela de la moitie
        for col in range(pixels):
            zn=complex(0,0)
            i = 1
            x = xmin+col*(xmax-xmin)/pixels
            y = ymax-line*(ymax-ymin)/pixels
            c=complex(x,y)
            while i<=bouclesmax and max(abs(c),abs(zn))<=2:
               zn = zn**n+c
               i += 1
            if i>bouclesmax and max(abs(c),abs(zn))<=2:     #on considere qu'il s'agit d'un point captif
                img[line,col] = (253*abs(zn)/2+178*(1-abs(zn)/2),187*abs(zn)/2+31*(1-abs(zn)/2),45*abs(zn)/2+31*(1-abs(zn)/2))  #coloration du pixel associe en triplet (R,V,B) en fonction du module en fin de boucle, peut etre modifiee selon les gouts de l'utilisateur
                img[pixels-1-line,col] = (253*abs(zn)/2+178*(1-abs(zn)/2),187*abs(zn)/2+31*(1-abs(zn)/2),45*abs(zn)/2+31*(1-abs(zn)/2)) #coloration du pixel symetrique
            else:       #il s'agit necessairement d'un point d'echappement
                img[line,col] = (26*(1-i/bouclesmax)+253*i/bouclesmax,42*(1-i/bouclesmax)+187*i/bouclesmax,108*(1-i/bouclesmax)+45*i/bouclesmax) #coloration du pixel associe en fonction du rang d'echappement
                img[pixels-1-line,col] = (26*(1-i/bouclesmax)+253*i/bouclesmax,42*(1-i/bouclesmax)+187*i/bouclesmax,108*(1-i/bouclesmax)+45*i/bouclesmax) #coloration du pixel symetrique



    duree = datetime.datetime.now() - start_delay
    print("Duree : "+str(duree.seconds)+" s")
    print("affichage")

    plt.imshow(img)
    plt.title("Mandelbrot-"+pixelsch+"-"+x0ch+"-"+y0ch+"-"+str(z))
    plt.show()

    infos = str(pixels)+"-"+str(bouclesmax)+"-"+str(z)+"-"+str(x0)+"-"+str(y0)
    mpimg.imsave("Mandelbrot-"+infos+".png",img)

    quitch = input("continue (rc), quit (other): ")