#pip install matplotlib si le module n'est pas deja present
import matplotlib.image as mpimg
import matplotlib.pyplot as plt

def orbite(a,b,x,y,n):

    fig = plt.figure()
    ax = fig.add_subplot(1, 1, 1)

    plt.axis('equal')
    # Centre les axes
    ax.spines['left'].set_position('center')
    ax.spines['bottom'].set_position('center')

    # Elimine les axes par defaut
    ax.spines['right'].set_color('none')
    ax.spines['top'].set_color('none')

    # definit la fenetre
    ax.set_xlim([-3.5,3.5])
    ax.set_ylim([-3.5,3.5])

    #definit et trace le cercle unite
    disk1 = plt.Circle((0, 0), 1, color= 'navy', fill=False)
    ax.add_artist(disk1)

    z=complex(x,y)
    plt.scatter(z.real,z.imag,color=(0,0,0))
    c=complex(a,b)
    for k in range(n): #boucle qui calcule et place chaque terme de la suite
        z=z**2+c
        plt.scatter(z.real,z.imag,color=(k/n,0,0))  #couleur rouge definie en fonction du rang de chaque terme, les premiers points sont fonces, plus le rang est haut et plus la couleur est claire

# parametres d'entree

quitch = ""

while quitch == "":

    nsch = input("Nombre de termes successifs de la suite a placer (10 par defaut): n =")
    ach = input("Partie reele de c (-0.5 par defaut): a = ")
    bch = input("Partie imaginaire de c (0.5 par defaut): b = ")
    xch = input("Premier terme de la suite (origine par defaut): x0=")
    ych =input("Premier terme de la suite (origine par defaut): y0=")

    if nsch == "":
        n = 10
    else :
        n = int(nsch)
    if ach == "":
        a=-0.5
    else :
        a=float(ach)

    if bch == "":
        b=0.5
    else :
        b=float(bch)

    if xch == "":
        x= 0
    else :
        x=float(xch)

    if ych == "":
        y= 0
    else :
        y=float(ych)

    orbite(a,b,x,y,n)

    plt.savefig("Orbite_pt-"+str(n)+'-'+str(a)+'-'+str(b)+'-'+str(x)+'-'+str(y)+'.png')


    plt.show()

    quitch = input("continue (rc), quit (other): ")