# L. Prot ensemble de Julia 30-1-19  v1.0
#
#pip install numpy, matplotlib si le module n'est pas deja present
#
#La couleur de chaque pixels est codee en (R,G,B)
#Le rouge est code (255,0,0), le vert (0,255,0), le bleu (0,0,255),
#le blanc (255,255,255) et le noir (0,0,0)

import matplotlib.image as mpimg
import matplotlib.pyplot as plt
import numpy as np
import datetime

#definit la fenetre:

xmin =-1.5
xmax = 1.5
ymin =-1.5
ymax = 1.5


quitch = ""

#demande d'entree des differents parametres

while quitch == "":

    pixels = input("Taille de l image (400 pixels par defaut) = ")
    a = input("Partie reele de c (-0.123 par defaut): a = ")
    b = input("Partie imaginaire de c (0.745 par defaut): b =")
    n = input("exposant (2 par defaut): n = ")
    N = input("boucles maxi (100 par defaut): ")
    z = input("zoom (1 par defaut): z =")
    x0 = input("Centre de la zone de zoom (0 par defaut): x0 =")
    y0 = input("Centre de la zone de zoom (0 par defaut): y0 =")

    if pixels == "": #par defaut
        pixels = 400
        p=200 #milieu de l'image, utile pour exploiter la symetrie

    else : #valeur entree
        pixels = int(pixels)
        p = int(pixels/2) #milieu de l'image
    if a == "":
        a=-0.123
    else :
        a=float(a)

    if b == "":
        b=0.745
    else :
        b=float(b)

    if x0 == "":
        x0=0
    else :
        x0=(float(x0)-(pixels/2))/(pixels)*(xmax-xmin)

    if y0 == "":
        y0=0
    else :
        y0=((pixels/2)-float(y0))/(pixels)*(ymax-ymin)

    if n == "":
        n=2
    else :
        n=int(n)

    if N == "":
       bouclesmax = 100
    else :
        bouclesmax = int(N)

    if z == "":
        z=1
    else :
        z=int(z)

    #adaptation de la fenetre si zoom:

    xmin = x0 + xmin/z
    ymin = y0 + ymin/z
    xmax = x0 + xmax/z
    ymax = y0 + ymax/z

    c=complex(a,b)


    print(pixels,a,b,bouclesmax,z,x0,y0)

    start_delay = datetime.datetime.now()   #permet de definir le temps de depart
    img = np.zeros((pixels,pixels,3),dtype=np.uint8)   #definit l'image comme une matrice de triplets (Rouge,Vert,Bleu) correspondant a la couleur de chaque pixels


    for line in range(p+1):  #boucles parcourant la grille de pixels, la symetrie des ensembles de Julia fait qu'il n'est pas necessaire d'aller au dela de la moitie

        for col in range(pixels):
            i = 1
            #coordonnees du point de depart:
            x = xmin+col*(xmax-xmin)/(pixels)
            y = ymax-line*(ymax-ymin)/(pixels)
            zn=complex(x,y)

            while i<=bouclesmax and max(abs(c),abs(zn))<=2:
               zn = zn**n+c
               i += 1
            if i>bouclesmax and max(abs(c),abs(zn))<=2:     #on considere qu'il s'agit d'un point captif
                img[line,col] = (255,251,213) #coloration du pixel associe en triplet (R,V,B), peut etre modifiee selon les gouts de l'utilisateur
                img[pixels-1-line,pixels-1-col] = (255,251,213) #coloration identique pour le pixel symetrique

            else:       #il s'agit necessairement d'un point d'echappement
                img[line,col] = (178*(1-i/bouclesmax)+255*i/bouclesmax,10*(1-i/bouclesmax)+251*i/bouclesmax,44*(1-i/bouclesmax)+213*i/bouclesmax) #coloration du pixel associe en fonction du rang d'echappement
                img[pixels-1-line,pixels-1-col] = (178*(1-i/bouclesmax)+255*i/bouclesmax,10*(1-i/bouclesmax)+251*i/bouclesmax,44*(1-i/bouclesmax)+213*i/bouclesmax) #coloration identique pour le pixel symetrique

    infos = str(pixels)+"-"+str(a)+"-"+str(b)+"-"+str(bouclesmax)+"-"+str(z)+"-"+str(x0)+"-"+str(y0)

    duree = datetime.datetime.now() - start_delay #temps de calcul de l'algorithme
    print("Duree : "+str(duree.seconds)+" s")
    print("Affichage")

    plt.imshow(img)
    plt.title("Julia-"+infos)
    plt.show()

    mpimg.imsave("ulia-"+infos+".png",img)

    quitch = input("continue (rc), quit (other): ")

